#!/usr/bin/perl -w

#    
$config="/etc/bforce/sln_sfp.conf";





###############################################################################
### Programm ################################################### do't edit! ###
###############################################################################



### Parse config ##############################################################
open(CONF,"< $config") || die $!;
undef %sql;

while(<CONF>){
$sql{host}=$1	if /^sql_host\s+(\S+)$/i;
$sql{user}=$1	if /^sql_user\s+(\S+)$/i;
$sql{pass}=$1	if /^sql_pass\s+(\S+)$/i;
$sql{db}=$1	if /^sql_db\s+(\S+)$/i;
$sql{area}=$1	if /^sql_tb_area\s+(\S+)$/i;
$sql{file}=$1	if /^sql_tb_file\s+(\S+)$/i;
$sql{ai}=$1	if /^tb_area_id\s+(\S+)$/i;
$sql{ap}=$1	if /^tb_area_path\s+(\S+)$/i;
$sql{aa}=$1	if /^tb_area_access\s+(\S+)$/i;
$sql{fi}=$1	if /^tb_file_id\s+(\S+)$/i;
$sql{ff}=$1	if /^tb_file_file\s+(\S+)$/i;
$sql{fd}=$1	if /^tb_file_desc\s+(\S+)$/i;
}

close(CONF);
die "Check SQL sets from config" if keys %sql != 12;



### Connect to MySQL server ###################################################
use DBI;
$dbh=DBI->connect("DBI:mysql:database=$sql{db};host=$sql{host}", $sql{user}, $sql{pass}) || $DBI::errstr;



### Areas #####################################################################
$sth=$dbh->prepare("SELECT $sql{ai},$sql{ap},$sql{aa} FROM $sql{area}");
$sth->execute() || $dbh->errstr;
die "No available area" unless $sth->rows;
(%path,%access)=();
while($_=$sth->fetch){
  $path{$_->[0]}=$_->[1];
$access{$_->[0]}=$_->[2];
}



### Get files #################################################################
print "Compare SQL base with disk:\n";
foreach $path (sort {$a<=>$b} keys %path){

# from sql
print "Work with SQL... ";
 $sth=$dbh->prepare("SELECT $sql{ff},$sql{fd},$sql{fi} FROM $sql{file} WHERE $sql{fi}=$path");
 $sth->execute();
  (%s,%i,%d,%f)=();
  $i=0;
  while($_=$sth->fetch){ ($f{$i},$d{$i},$i{$i},$s{$_->[0]})=($_->[0],$_->[1],$_->[2],$i); $i++ }


# dupe in sql base
delete $f{$_} foreach(values %s);
print "kill ".(keys %f)." dupe... " if keys %f > 0;


foreach(keys %f){
 $dbh->do(sprintf("DELETE FROM $sql{file} WHERE $sql{ff}=%s AND $sql{fi}=$i{$_}",$dbh->quote($f{$_})));
 $dbh->do(sprintf("INSERT INTO $sql{file} VALUES($i{$_},%s,%s)",$dbh->quote($f{$_}),$dbh->quote($d{$_}))) || die $dbh->errstr;
}



# from disk
print "path $path{$path}... ";
 opendir(DIR,$path{$path}) || die "$path: $!";
  %dir=map {$_,$_} grep {-f "$path{$path}/$_"} readdir(DIR);
 closedir(DIR);

print " ok\n";

# new files
foreach(keys %dir){
 if(not exists $s{$_}){
  print "Insert into SQL $_\n";
   $dbh->do(sprintf("INSERT INTO $sql{file} VALUES($path,%s,%s)",$dbh->quote($_),$dbh->quote(getdesc("$path{$path}/$_")))) || die $dbh->errstr;
 }
}


# remove files
foreach(keys %s){
 if(not exists $dir{$_}){
  print "Delete from SQL $_\n";
  $dbh->do(sprintf("DELETE FROM $sql{file} WHERE $sql{ff}=%s AND $sql{fi}=$path",$dbh->quote($_))) || die $dbh->errstr;
 }
}



}


print "All successfully !\n";
exit 0;











sub getdesc{

$_[0]=~s/(\W)/\\$1/g;

###############################################################################
############# description set result of exec `file` unix command ##############
###############################################################################

chomp($desc=`file -b $path{$path}/$_`);

###############################################################################
###############################################################################
###############################################################################

$desc;
}
